﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;

namespace XDG_MVVM_ButtonInfo
{
    class ViewModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;

        public ObservableCollection<Employee> data { get; set; }
        public RelayCommand getRowData { get; set; }
        public RelayCommand bringCellIntoView { get; set; }
        public bool canAddRow { get; set; }
        public Employee Arisha { get; set; }

        public ObservableCollection<Employee> emplooyeList { get; set; }

        public ViewModel()
        {
            emplooyeList = GenerateData();
            getRowData = new RelayCommand(buttonClicked);
            bringCellIntoView = new RelayCommand(bringDataItemIntoView);
            canAddRow = true;
            Arisha = emplooyeList[27];
        }

        public void buttonClicked(object o)
        {
            DataRecord record = o as DataRecord;
            string result = string.Empty;
            var currentItem = record.DataItem;
            foreach (var prop in currentItem.GetType().GetProperties())
            {
                string name = prop.Name;
                var value = prop.GetValue(currentItem);
                result += name + ": " + value.ToString() + Environment.NewLine;
            }
            MessageBox.Show(result);
            canAddRow = !canAddRow;
        }

        public void bringDataItemIntoView(object o)
        {
            var grid = o as XamDataGrid;
            grid.SelectedDataItem = this.Arisha;
            grid.BringDataItemIntoView(this.Arisha, false);
        }


        public ObservableCollection<Employee> GenerateData()
        {
            data = new ObservableCollection<Employee>()
                {
                   new Employee("John Smith", 5250.50, 20, new DateTime(2008,01,01)),
                   new Employee("Hania Dillard", 932874.22, 0, new DateTime(2012,03,17)),
                   new Employee("Devin Burgess", 6944.10, -10, new DateTime(2016,03,22)),
                   new Employee("Arisha Woodcock", 57449.10, 15, new DateTime(2018,11,09)),
                   new Employee("Celia Hogg", 123.50, -3, new DateTime(2011,09,11)),
                   new Employee("Payton Carr", 656749.50, 4, new DateTime(2014,12,26)),
                   new Employee("Angela Mclaughlin", 4894.50, 12, new DateTime(2005,06,30)),
                   new Employee("Ailsa Curtis", 5587.50, -23, new DateTime(2013,11,21)),
                   new Employee("Oscar Hubbard", 3745.50, -17, new DateTime(1986,09,29)),
                   new Employee("Naeem Hall", 54892.50, 10, new DateTime(1993,02,17)),
                   new Employee("Kaeden Vasquez", 56868.50, 3, new DateTime(1996,12,10)),
                   new Employee("Branden Gregory", 4974.50, -6, new DateTime(2017,12,10)),
                   new Employee("John1 Smith", 5250.50, 20, new DateTime(2008,01,01)),
                   new Employee("Hania1 Dillard", 932874.22, 0, new DateTime(2012,03,17)),
                   new Employee("Devin1 Burgess", 6944.10, -10, new DateTime(2016,03,22)),
                   new Employee("Arisha1 Woodcock", 57449.10, 15, new DateTime(2018,11,09)),
                   new Employee("Celia1 Hogg", 123.50, -3, new DateTime(2011,09,11)),
                   new Employee("Payton1 Carr", 656749.50, 4, new DateTime(2014,12,26)),
                   new Employee("Angela1 Mclaughlin", 4894.50, 12, new DateTime(2005,06,30)),
                   new Employee("Ailsa1 Curtis", 5587.50, -23, new DateTime(2013,11,21)),
                   new Employee("Oscar1 Hubbard", 3745.50, -17, new DateTime(1986,09,29)),
                   new Employee("Naeem1 Hall", 54892.50, 10, new DateTime(1993,02,17)),
                   new Employee("Kaeden1 Vasquez", 56868.50, 3, new DateTime(1996,12,10)),
                   new Employee("Branden1 Gregory", 4974.50, -6, new DateTime(2017,12,10)),
                   new Employee("John2 Smith", 5250.50, 20, new DateTime(2008,01,01)),
                   new Employee("Hania2 Dillard", 932874.22, 0, new DateTime(2012,03,17)),
                   new Employee("Devin2 Burgess", 6944.10, -10, new DateTime(2016,03,22)),
                   new Employee("Arisha2 Woodcock", 57449.10, 15, new DateTime(2018,11,09)),
                   new Employee("Celia2 Hogg", 123.50, -3, new DateTime(2011,09,11)),
                   new Employee("Payton2 Carr", 656749.50, 4, new DateTime(2014,12,26)),
                   new Employee("Angela2 Mclaughlin", 4894.50, 12, new DateTime(2005,06,30)),
                   new Employee("Ailsa2 Curtis", 5587.50, -23, new DateTime(2013,11,21)),
                   new Employee("Oscar2 Hubbard", 3745.50, -17, new DateTime(1986,09,29)),
                   new Employee("Naeem2 Hall", 54892.50, 10, new DateTime(1993,02,17)),
                   new Employee("Kaeden2 Vasquez", 56868.50, 3, new DateTime(1996,12,10)),
                   new Employee("Branden2 Gregory", 4974.50, -6, new DateTime(2017,12,10))
                };
            NotifyPropertyChanged("data");
            return data;
        }

        protected void NotifyPropertyChanged(string propertyName)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
